/******************************************************************************
* Sous programme de traitement de l'IT en reception I2C 
* Machine  tats rpondant aux demandes du maitre.
* IT lors de la dtection de START, RESTART ou STOP
* Recption de l'adresse (donne non utile puisque IT)
* reception de la donne de configuration
* reception du nombre n de paramtres  transmettre
* emission de n paramtres
*
* La machine a tat gre les ACK et NON ACK
* Le port I2C doit tre configur en mode esclave , SSPADD contient l'adresse I2C
* init_i2c() initialise le port i2c en mode esclave et active les interruptions
*****************************************************************************/

#include "i2c.h" // bibliotheque Microchip
#define i2cAddress 0x42  // adresse de l'esclave

/** VARIABLES GLOBALES********************************************************/
unsigned char dataAtransmettre[10]; // table  transmettre
unsigned char data;					// donnee reu sur I2C
unsigned char message[40]; 		// tampon reception
unsigned char messRecu;			// indique qu'un message a t reu

void init_i2c(void)
{
OpenI2C(SLAVE_7, SLEW_ON);// Initialise le module I2C 400kHz  @32MHz
	SSPADD = i2cAddress; // adresse esclave mode adresse sur 7-bit
	PIE1bits.SSPIE = 1;  // active les IT sur  MSSP
	INTCONbits.PEIE = 1;  // avtive les IT sur peripheriques
	INTCONbits.GIEH =1;  // autorise toutes les IT
}

 #pragma interrupt high_isr
 void high_isr(void)
 {
 static unsigned char etatI2c=0, nb,nbEmissions;
 unsigned char data_SSPBUF; 
 static unsigned char *ptrRecpt ;

 if( PIR1bits.SSPIF ) 
	{
		data_SSPBUF=SSPBUF;	// le buffer doit toujours etre lu pour acquitement
		switch (etatI2c)
		{
			// attend une adresse
			case (0) : 	if ((SSPSTATbits.D_A==0) && (SSPSTATbits.R_W == 0)) // c'est une adresse I2c pour ecriture 
					    etatI2c=1; 
						else etatI2c=0; 
						break;
			// attend une donnee reception de data
			case (1) :  if ((SSPSTATbits.D_A==1)&& (SSPSTATbits.R_W == 0))	// c'est une donnee en ecriture
						{
							data=data_SSPBUF;
							etatI2c=2;
						}	
						else etatI2c=0;
						break;
			// attend une donnee reception de nb
			case (2) :  if ((SSPSTATbits.D_A==1)&& (SSPSTATbits.R_W == 0))	// c'est une donnee en ecriture	
						{
							nb=data_SSPBUF;
							nbEmissions=0;
							if (data & 0b10000000) 
								{
									ptrRecpt=message;	// pointe debut message a recevoir
									etatI2c=4; // reception d'un message
								}
							else etatI2c=3;  // transmission des donnees demandees
						}	
						else etatI2c=0;
						break;
			case (3) : 	if (SSPSTATbits.R_W == 1) // c'est une  pour lecture
						{
							SSPBUF=dataAtransmettre[nbEmissions++];	// renvoie les donnees 
							SSPCON1bits.CKP=1; 				// nlb sur CLK preient maitre que data est prete
							while (SSPSTATbits.BF);			// attend SSPBUFF vide
							if (nbEmissions == nb) 
								{	etatI2c=0; 
									while(!SSPSTATbits.P); 	// attend STOP
									IdleI2C();
								}	
						}
						else etatI2c=0; 
						break;	
			case (4) :  if ((SSPSTATbits.D_A==1)&& (SSPSTATbits.R_W == 0))	// c'est une donnee en ecriture
						{
							*ptrRecpt=data_SSPBUF;
							ptrRecpt++;
							if (!data_SSPBUF) 
										{
											messRecu=1;
											etatI2c=0;
										}
						}	
						else etatI2c=0;
						break;
			default : 	etatI2c=0;
						break;
		}
	PIR1bits.SSPIF = 0;
	}	
	else
	{ 
		Nop();
	}
 }
 

 /** Vecteur IT haute *****************************************/
 #pragma code high_vector=0x08
 void interrupt_at_high_vector(void)
 {
   _asm goto high_isr _endasm
 }
 #pragma code
