// MCC18 : Exemple de gestion des communication I2C en mode maitre
// Utilisation du peripherique intgr au PIC18 et de la bibliotheque MCC18 i2c.h 
// Le bus i2c est connect sur RC3,RC4 (SCL, SDA)
// C.Dupaty 05/2012
#include <p18f2620.h>

#include "i2c.h"

#define temp 30000
#define nbdRecept 4 // nombre de donnees demandees

unsigned char tampon[10];
unsigned char i2cAdress;
unsigned char message[]="Communications I2C";

void tempo(unsigned int i)
{
	while(i--);
}


void main (void)
{unsigned char i;
	init_horloge_interne(); // 8MHz
	OpenI2C(MASTER, SLEW_ON);// Initialize I2C module
	SSPADD = 0x14;              //400kHz Baud clock(9) @32MHz
	i2cAdress=0x42;
	TRISA=0xFF;	// port tests
	TRISB=0;
	tempo(temp);
// mode emission de message b7 de data=1
		if (i2cEchange(i2cAdress,0b10000000,nbdRecept,message))
			{
				Nop();
			}
// mode demande de donnees b7 de data=0 (ici b7 de PORTA est forc  0).
	while(1)
	{
		if (i2cEchange(i2cAdress,PORTA&0b01111111,nbdRecept,tampon))
			{
				Nop();
			}
		PORTB=tampon[0];
		tempo(temp);
	}
}

